/***********************************************************************
 * File: days-test.c
 * 	(Extracted from
 *	   "$Id: days-test.c,v 1.8 2007/04/15 11:14:14 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This C source implements the test program for is_valid_date() and
 * date_in_English() API-s.
 *
 * Copyright (C) 2005-2006 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

#include "days.h"

int main(int ac, char **av)
{
	long long	count;
	size_t		i, j;
	char		*mmdd[] = {
			  "0000", "0100", "0101", "0131", "0132"
			, "0200", "0201", "0228", "0229", "0230"
			, "0300", "0301", "0331", "0332"
			, "0400", "0401", "0430", "0431"
			, "0500", "0501", "0531", "0532"
			, "0600", "0601", "0630", "0631"
			, "0700", "0701", "0731", "0732"
			, "0800", "0801", "0831", "0832"
			, "0900", "0901", "0930", "0931"
			, "1000", "1001", "1031", "1032"
			, "1100", "1101", "1130", "1131"
			, "1200", "1201", "1231", "1232"
			}
			, *year[] = {
			  "0000", "0001", "", "0", "1", "2", "3", "4"
			, "5", "6", "7", "8", "9"
			, "10", "11", "12", "13", "14"
			, "15", "16", "17", "18", "19"
			, "110", "111", "112", "113", "114"
			, "115", "116", "117", "118", "119"
			, "2000", "2001", "2002", "2003", "2004"
			, "2005", "2006", "2007", "2008", "2009"
			, "4294967295", "4294967296"
			}
			, date[15], str[26], *datep
			, org_date[sizeof(date)];
	Day_of_week_e	day_of_week;
	char		**sv_av, *dow_str;
	int		sv_ac;

	sv_ac = ac; sv_av = av; ac = sv_ac; av = sv_av;

	datep	= strcpy(date, "00001341");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00010101");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00010201");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00010301");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00011231");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00040101");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00040201");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00040301");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00041231");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "10000101");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "10000201");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "10000301");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "10001231");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "20000101");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "20000201");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "20000301");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "20001231");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);

	printf("-----------------------------------\n")
	; (void)fflush(stdout);
	strcpy(date, "00010101");
	str[0]	= '\0';
	printf("days_count(\"%s\", %ld) "
		"returns %lld.\n"
		, date, (long)strlen(date)
		, days_count(date, strlen(date))
		); (void)fflush(stdout);
	strcat(strcat(str, year[(sizeof(year) / sizeof(year[0])) - 2])
		, "1231"
		);
	printf("days_count(\"%s\", %ld) "
		"returns %lld.\n"
		, str, (long)strlen(str)
		, days_count(str, strlen(str))
		); (void)fflush(stdout);
	count	= diff_dates(date, strlen(date), str, strlen(str));
	if (count == LLONG_MIN) {
		printf("!!ERROR!! ");
	}
	printf("diff_dates(\"%s\", %ld,"
		" \"%s\", %ld) "
		" returns %lld.\n"
		,	date, (long)strlen(date)
		, str, (long)strlen(str)
		,		count
		); (void)fflush(stdout);
	count	= diff_dates(str, strlen(str), date, strlen(date));
	if (count == LLONG_MIN) {
		printf("!!ERROR!! ");
	}
	printf("diff_dates(\"%s\", %ld,"
		" \"%s\", %ld) "
		" returns %lld.\n"
		,	str, (long)strlen(str)
		, date, (long)strlen(date)
		,		count
		); (void)fflush(stdout);
	printf("\n"); (void)fflush(stdout);

	for (i = 0; i < sizeof(year) / sizeof(year[0]); ++i) {
		for (j = 0; j < sizeof(mmdd) / sizeof(mmdd[0]); ++j) {
			DAYS_FMT	fmt;
			char		*days;
			int		result;

			date[0]	= '\0';
			strcat(strcat(date, year[i]), mmdd[j]);
			printf("date is \"%s\".\n", date
			); (void)fflush(stdout);

			result	= is_valid_date(date, strlen(date));
			if (result != DAYS_TRUE) {
				printf("!!ERROR!! ");
			}
			printf("is_valid_date(\"%s\", %lu) "
				"returns %d.\n"
				,	date
				,	(unsigned long)strlen(date)
				, result
				); (void)fflush(stdout);

			fmt	= DAYS_FMT_EUROPEAN;
			days	= date_in_English(date
						, strlen(date)
						, fmt
						, str
						, sizeof(str)
						);
			if (days == NULL) {
				printf("!!ERROR!! ");
			}
			printf("date_in_English(\"%s\", %ld, %d, %p"
				", %ld) returns %p."
				, date, (long)strlen(date), fmt, str
				, (long)sizeof(str), days
				);
			if (days != NULL) {
				printf(" [str is \"%s\"]", str);
			}
			printf("\n"); (void)fflush(stdout);

			fmt	= DAYS_FMT_AMERICAN;
			days	= date_in_English(date
						, strlen(date)
						, fmt
						, str
						, sizeof(str)
						);
			if (days == NULL) {
				printf("!!ERROR!! ");
			}
			printf("date_in_English(\"%s\", %ld, %d, %p"
				", %ld) returns %p."
				, date, (long)strlen(date), fmt, str
				, (long)sizeof(str), days
				);
			if (days != NULL) {
				printf(" [str is \"%s\"]", str);
			}
			printf("\n"); (void)fflush(stdout);

			count = days_count(date, strlen(date));
			if (count == LLONG_MIN) {
				printf("!!ERROR!! ");
			}
			printf("days_count(\"%s\", %ld) returns %lld.\n"
				,	date, (long)strlen(date), count
				); (void)fflush(stdout);

			day_of_week	= day_of_week(count);
			dow_str	= day_of_week_str(count);
			printf("day_of_week(%lld) returns %d.\n"
				,	count,	(int)day_of_week
				); (void)fflush(stdout);
			printf("day_of_week_str(%lld) returns "
							"@%p[%s].\n"
				,	count
				,	dow_str
				,	((dow_str != NULL)?
							dow_str: "(n/a)"
					)
				); (void)fflush(stdout);

			str[0]	= '\0';
			strcat(strcat(str, year[i])
				, mmdd[(j == sizeof(mmdd)
						/ sizeof(mmdd[0]) - 1)?
							0: j + 1
					]
				);
			printf("str is \"%s\".\n", str
			); (void)fflush(stdout);
			count = diff_dates(str
					, strlen(str)
					, date
					, strlen(date)
					);
			if (count == LLONG_MIN) {
				printf("!!ERROR!! ");
			}
			printf("diff_dates(\"%s\", %ld,"
				" \"%s\", %ld) "
				" returns %lld.\n"
				,	str, (long)strlen(str)
				, date, (long)strlen(date)
				,		count
				); (void)fflush(stdout);
		}
		printf("\n"); (void)fflush(stdout);
	}

	strcpy(date, "00010101");
	str[0]	= '\0';
	printf("days_count(\"%s\", %ld) "
		"returns %lld.\n"
		, date, (long)strlen(date)
		, days_count(date, strlen(date))
		); (void)fflush(stdout);
	strcat(strcat(str, year[(sizeof(year) / sizeof(year[0])) - 2])
		, "1231"
		);
	printf("days_count(\"%s\", %ld) "
		"returns %lld.\n"
		, str, (long)strlen(str)
		, days_count(str, strlen(str))
		); (void)fflush(stdout);
	printf("is_valid_date(\"%s\", %lu) returns %d.\n"
		,	str, (unsigned long)strlen(str)
		, is_valid_date(str, strlen(str))
		); (void)fflush(stdout);
	count	= diff_dates(date, strlen(date), str, strlen(str));
	if (count == LLONG_MIN) {
		printf("!!ERROR!! ");
	}
	printf("diff_dates(\"%s\", %ld,"
		" \"%s\", %ld) "
		" returns %lld.\n"
		,	date, (long)strlen(date)
		, str, (long)strlen(str)
		,		count
		); (void)fflush(stdout);
	count	= diff_dates(str, strlen(str), date, strlen(date));
	if (count == LLONG_MIN) {
		printf("!!ERROR!! ");
	}
	printf("diff_dates(\"%s\", %ld,"
		" \"%s\", %ld) "
		" returns %lld.\n"
		,	str, (long)strlen(str)
		, date, (long)strlen(date)
		,		count
		); (void)fflush(stdout);

	printf("----------------------------------\n")
	; (void)fflush(stdout);
	/* error cases... */
	count	= 0; /* invalid arguments */
	datep	= days_count_to_date_str(count
					, NULL
					, 8
					);
	printf("days_count_to_date_str(day_count (%lld), "
		"date@%p, sz (%d)) returns @%p [%s](len=%lu).\n"
		,				count
		, NULL, 8, datep
		, ((datep == NULL)? "(n/a)": datep)
		, (unsigned long)((datep == NULL)?
					(size_t)INT_MIN: strlen(datep)
					)
		); (void)fflush(stdout);

	count	= 1;
	datep	= days_count_to_date_str(count
					, NULL /* invalid arguments */
					, 8
					);
	printf("days_count_to_date_str(day_count (%lld), "
		"date@%p, sz (%d)) returns @%p [%s](len=%lu).\n"
		,				count
		, NULL, 8, datep
		, ((datep == NULL)? "(n/a)": datep)
		, (unsigned long)((datep == NULL)?
					(size_t)INT_MIN: strlen(datep)
					)
		); (void)fflush(stdout);

	count	= 1;
	datep	= days_count_to_date_str(count
					, date
					, 8 /* invalid arguments */
					);
	printf("days_count_to_date_str(day_count (%lld), "
		"date@%p, sz (%d)) returns @%p [%s](len=%lu).\n"
		,				count
		, date, 8, datep
		, ((datep == NULL)? "(n/a)": datep)
		, (unsigned long)((datep == NULL)?
					(size_t)INT_MIN: strlen(datep)
					)
		); (void)fflush(stdout);

	/* normal end cases... */
	for (i = 0; i < sizeof(year) / sizeof(year[0]); ++i) {
	for (j = 0; j < sizeof(mmdd) / sizeof(mmdd[0]); ++j) {
		(void)snprintf(date, sizeof(date)
				, "%s%s", year[i], mmdd[j]
				);
		strcpy(org_date, date);
		if ((count = days_count(date, strlen(date))) < 1) {
			continue; /* skip `invalid arguments` case*/
		}
		printf("{org_date [%s](len=%lu)} "
			, org_date, (unsigned long)strlen(org_date)
			); (void)fflush(stdout);
		datep	= days_count_to_date_str(count
						, date
						, sizeof(date)
						);
		printf("days_count_to_date_str(day_count (%lld), "
			"date@%p, sz (%lu)) "
			"returns @%p [%s](len=%lu).\n"
			,				count
			, date, (unsigned long)sizeof(date)
			, datep, ((datep == NULL)? "(n/a)": datep)
			, (unsigned long)((datep == NULL)?
					(size_t)INT_MIN: strlen(datep)
					)
			); (void)fflush(stdout);
		if (((datep != NULL) && strcmp(datep, org_date) != 0)
		&& days_count(datep, strlen(datep)) != count) {
			printf("!!!FATAL!!! days_count_to_date_str()\n"
				); (void)fflush(stdout);
		}
	}}

	exit(0);
}
